Package: groovy.lang

## [Java] Class ListWithDefaultT

- groovy.lang.ListWithDefault

- All Implemented Interfaces and Traits:
    List

      public final class ListWithDefault
      extends Object

  A wrapper for List which automatically grows the list when either get(int) or getAt(int) is called with an index greater than or equal to `size()`.

  Since:
    1.8.7

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `boolean` | `add(T t)`
    `` | `void` | `add(int i, T t)`
    `` | `boolean` | `addAll(Collection<? extends T> ts)`
    `` | `boolean` | `addAll(int i, Collection<? extends T> ts)`
    `` | `void` | `clear()`
    `` | `boolean` | `contains(Object o)`
    `` | `boolean` | `containsAll(Collection<?> objects)`
    `` | `boolean` | `equals(Object obj)`
    `` | `T` | `get(int index)` Returns the element at the given index but grows the list if needed.
    `` | `T` | `getAt(int index)` Overwrites subscript operator handling by redirecting to get(int).
    `` | `List<T>` | `getDelegate()`
    `` | `Closure` | `getInitClosure()`
    `` | `int` | `hashCode()`
    `` | `int` | `indexOf(Object o)`
    `` | `boolean` | `isEmpty()`
    `` | `boolean` | `isLazyDefaultValues()`
    `` | `Iterator<T>` | `iterator()`
    `` | `int` | `lastIndexOf(Object o)`
    `` | `ListIterator<T>` | `listIterator()`
    `` | `ListIterator<T>` | `listIterator(int i)`
    `` | `static ListWithDefault<T>` | `newInstance(List<T> items, boolean lazyDefaultValues, Closure initClosure)`
    `` | `boolean` | `remove(Object o)`
    `` | `T` | `remove(int i)`
    `` | `boolean` | `removeAll(Collection<?> objects)`
    `` | `boolean` | `retainAll(Collection<?> objects)`
    `` | `T` | `set(int i, T t)`
    `` | `int` | `size()`
    `` | `ListWithDefault<T>` | `subList(int fromIndex, int toIndex)` Returns a view of a portion of this list.
    `` | `Object[]` | `toArray()`
    `` | `T[]` | `toArray(T[] ts)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public boolean add(T t)

    - #### public void add(int i, T t)

    - #### public boolean addAll(Collection<? extends T> ts)

    - #### public boolean addAll(int i, Collection<? extends T> ts)

    - #### public void clear()

    - #### public boolean contains(Object o)

    - #### public boolean containsAll(Collection<?> objects)

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public boolean equals(Object obj)

    - #### public T get(int index)

      Returns the element at the given index but grows the list if needed. If the requested `index` is greater than or equal to `size()`, the list will grow to the new size and a default value calculated using the `initClosure` will be used to populate the missing value and returned.

      If `lazyDefaultValues` is `true` any gaps when growing the list are filled with nulls. Subsequent attempts to retrieve items from the list from those gap index values will, upon finding null, call the `initClosure` to populate the list for the given list value. Hence, when in this mode, nulls cannot be stored in this list. If `lazyDefaultValues` is `false` any gaps when growing the list are filled eagerly by calling the `initClosure` for all gap indexes during list growth. No calls to `initClosure` are made except during list growth and it is ok to store null values in the list when in this mode.

      This implementation breaks the contract of List.get as it a) possibly modifies the underlying list and b) does NOT throw an IndexOutOfBoundsException when `index < 0 || index >= size()`.

      Parameters:
        `index` - an index (might be greater or equal to `size()`, or smaller than 0)
      Returns:
        the value at the given `index` or the default value

    - #### public T getAt(int index)

      Overwrites subscript operator handling by redirecting to get(int).

      Parameters:
        `index` - an index (might be greater or equal to `size()`, or smaller than 0)
      Returns:
        the value at the given `index` or the default value

    - #### public List<T> getDelegate()

    - #### public Closure getInitClosure()

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public int hashCode()

    - #### public int indexOf(Object o)

    - #### public boolean isEmpty()

    - #### public boolean isLazyDefaultValues()

    - #### public Iterator<T> iterator()

    - #### public int lastIndexOf(Object o)

    - #### public ListIterator<T> listIterator()

    - #### public ListIterator<T> listIterator(int i)

    - #### public static ListWithDefault<T> newInstance(List<T> items, boolean lazyDefaultValues, Closure initClosure)

    - #### public boolean remove(Object o)

    - #### public T remove(int i)

    - #### public boolean removeAll(Collection<?> objects)

    - #### public boolean retainAll(Collection<?> objects)

    - #### public T set(int i, T t)

    - #### public int size()

    - #### public ListWithDefault<T> subList(int fromIndex, int toIndex)

      Returns a view of a portion of this list. This method returns a list with the same lazy list settings as the original list.

      Parameters:
        `fromIndex` - low endpoint of the subList (inclusive)
        `toIndex` - upper endpoint of the subList (exclusive)
      Returns:
        a view of a specified range within this list, keeping all lazy list settings

    - #### public Object[] toArray()

    - #### public T[] toArray(T[] ts)